export class DataFactory {
    make(model) {
        return new Proxy({}, {
            get: (target, key, receiver) => {
                key = `${key}`;
                if (key.endsWith('$')) {
                    // subscribe
                    key = key.substring(0, key.length - 1);
                    return model.getSubscribeItemFunc(key);
                }
                else {
                    return model.getItem(key);
                }
            },
            set: (target, key, value) => {
                model.setItem(key, value);
                return true;
            },
            has: (target, key) => {
                return model.hasItem(key);
            },
            deleteProperty: (target, key) => {
                model.removeItem(key);
                return true;
            },
        });
    }
}
//# sourceMappingURL=data-factory.class.js.map