import { KMap } from '../..';
import { SyncAbstractDriverInterface } from '../../drivers/sync-abstract-driver.class';
import { BaseModel } from './base-model.class';
import { ModelOptionsInterface } from './model-options.interface';
export declare class CollectionModel<DataType = any, DriverType extends SyncAbstractDriverInterface | undefined = undefined> extends BaseModel<Record<string, DataType>, DriverType> {
    constructor(options: Partial<ModelOptionsInterface>);
    private nextPrimaryKey;
    seeded: boolean;
    _curdSubscribeFuncs: {
        insertItem: Record<number, Function>;
        setItem: Record<number, Function>;
        removeItem: Record<number, Function>;
    };
    insertItem(item: DataType): string;
    bulkInsertItem(items: Array<DataType>): Array<string>;
    insertItem$<Key extends keyof DataType>(closFunc: (key: Key, value: DataType[Key]) => void): () => boolean;
    all(): KMap<DataType>;
    seed(seed: Function | Array<DataType>): void;
}
